{ Testprogamm  Siro: 05.11.2021 }
{ SetFocus löst kein Invalidate aus }
unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

Type TTestComp = class(TCustomControl)
  protected
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure paint;   override;
    procedure DoExit;  override; // zwingend erforderlich zum Neuzeichnen
    procedure DoEnter; override; // zwingend erforderlich zum Neuzeichnen
end;

var tc:TTestComp;

implementation
// ich möchte, dass der Focus automatisch an die Komponente
// übergeben wird, wenn sich die Maus darüber bewegt
procedure TTestComp.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  SetFocus;  // bei Mausbewegungen den Focus setzen
end;

procedure TTestComp.paint;
begin
  if Focused then canvas.brush.color:=clGreen  // grün wenn Focus
             else canvas.brush.color:=clWhite; // sonst weiss
  canvas.FillRect(ClientRect);
end;

// wenn die Komponente den Focus verliert, muss sie neu gezeichnet werden
procedure TTestComp.DoExit;
begin
  inherited;
//  invalidate;      // <======= wird fast immer benötigt ???
end;

// wenn die Komponente den Focus erhält, muss sie neu gezeichnet werden
procedure TTestComp.DoEnter;
begin
  inherited;
//  invalidate;      //  <======= wird fast immer benötigt ???
end;

// zum Testen: wenn die Maustaste gedrückt wird NEU ZEICHNEN
procedure TTestComp.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   invalidate;    // zum testen: Komponente MUSS neu gezeichnet werden
end;

{$R *.lfm}

{ TForm1 }



procedure TForm1.FormCreate(Sender: TObject);
begin
   tc:=TTestComp.create(self);
   tc.SetBounds(20,20,100,100);
   tc.parent:=self;
end;


end.

